(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/animations'), require('@ionic/angular'), require('rxjs'), require('rxjs/operators'), require('@angular/common/http'), require('@ionic-native/app-version/ngx'), require('@ionic-native/device/ngx'), require('@ionic-native/http/ngx'), require('@ionic-native/media/ngx'), require('@ionic-native/native-storage/ngx'), require('@ionic-native/status-bar/ngx'), require('@ionic-native/navigation-bar/ngx'), require('@ionic-native/admob/ngx'), require('@ionic-native/android-full-screen/ngx'), require('@ionic-native/native-audio/ngx'), require('@ionic-native/deeplinks/ngx')) :
    typeof define === 'function' && define.amd ? define('ionic-angular-utilities', ['exports', '@angular/core', '@angular/common', '@angular/animations', '@ionic/angular', 'rxjs', 'rxjs/operators', '@angular/common/http', '@ionic-native/app-version/ngx', '@ionic-native/device/ngx', '@ionic-native/http/ngx', '@ionic-native/media/ngx', '@ionic-native/native-storage/ngx', '@ionic-native/status-bar/ngx', '@ionic-native/navigation-bar/ngx', '@ionic-native/admob/ngx', '@ionic-native/android-full-screen/ngx', '@ionic-native/native-audio/ngx', '@ionic-native/deeplinks/ngx'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['ionic-angular-utilities'] = {}, global.ng.core, global.ng.common, global.ng.animations, global.angular, global.rxjs, global.rxjs.operators, global.ng.common.http, global.ngx, global.ngx$1, global.ngx$3, global.ngx$4, global.ngx$2, global.ngx$5, global.ngx$6, global.ngx$9, global.ngx$7, global.ngx$8, global.ngx$a));
}(this, (function (exports, core, common, animations, angular, rxjs, operators, http, ngx, ngx$1, ngx$3, ngx$4, ngx$2, ngx$5, ngx$6, ngx$9, ngx$7, ngx$8, ngx$a) { 'use strict';

    var CentralizerComponent = /** @class */ (function () {
        function CentralizerComponent() {
        }
        return CentralizerComponent;
    }());
    CentralizerComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'centralizer, [centralizer]',
                    template: "<div class=\"centering-container\">\n  <div class=\"centered-container\">\n    <ng-content></ng-content>\n  </div>\n</div>",
                    styles: [""]
                },] }
    ];

    var CentralizerModule = /** @class */ (function () {
        function CentralizerModule() {
        }
        return CentralizerModule;
    }());
    CentralizerModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        CentralizerComponent
                    ],
                    imports: [
                        common.CommonModule
                    ],
                    exports: [
                        CentralizerComponent
                    ]
                },] }
    ];

    var DebounceButtonComponent = /** @class */ (function () {
        function DebounceButtonComponent() {
            this.debounceClick = new core.EventEmitter();
            this.animationState = 'wait';
        }
        DebounceButtonComponent.prototype.animateButton = function () {
            var _this = this;
            if (this.animationTimeout)
                clearTimeout(this.animationTimeout);
            this.animationState = 'pressed';
            this.animationTimeout = setTimeout(function () {
                _this.animationState = 'wait';
            }, 200);
        };
        DebounceButtonComponent.prototype.onDebounceClick = function (event) {
            this.debounceClick.emit(event);
        };
        return DebounceButtonComponent;
    }());
    DebounceButtonComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'debounce-button',
                    template: "<ion-button debounceClick [fill]=\"fill\" [disabled]=\"disabled\" [shape]=\"shape\" [color]=\"color\" [ngClass]=\"cssClass\" [@buttonState]=\"animationState\" (click)=\"animateButton()\"\n  [debounceTime]=\"debounce\" (debounceClick)=\"onDebounceClick($event)\">\n  <ng-content></ng-content>\n</ion-button>",
                    animations: [
                        animations.trigger('buttonState', [
                            animations.state('wait', animations.style({
                                transform: 'scale(1)'
                            })),
                            animations.state('pressed', animations.style({
                                transform: 'scale(1.1)'
                            })),
                            animations.transition('wait => pressed', animations.animate('150ms ease-in')),
                            animations.transition('pressed => wait', animations.animate('150ms ease-out'))
                        ])
                    ],
                    styles: ["ion-button{--padding-end:var(--button-padding-end,0)!important;--padding-start:var(--button-padding-start,0)!important;--ripple-color:transparent!important;margin:var(--margin-top,0) var(--margin-right,0) var(--margin-bottom,0) var(--margin-left,0)!important;min-width:var(--min-width)!important;width:var(--width)!important}"]
                },] }
    ];
    DebounceButtonComponent.ctorParameters = function () { return []; };
    DebounceButtonComponent.propDecorators = {
        cssClass: [{ type: core.Input }],
        fill: [{ type: core.Input }],
        disabled: [{ type: core.Input }],
        shape: [{ type: core.Input }],
        color: [{ type: core.Input }],
        debounce: [{ type: core.Input }],
        debounceClick: [{ type: core.Output }]
    };

    var DebounceClickDirective = /** @class */ (function () {
        function DebounceClickDirective() {
            this.debounceTime = 500;
            this.debounceClick = new core.EventEmitter();
            this.clicks = new rxjs.Subject();
        }
        DebounceClickDirective.prototype.ngOnInit = function () {
            var _this = this;
            this.subscription = this.clicks.pipe(operators.debounceTime(this.debounceTime))
                .subscribe(function (event) { return _this.debounceClick.emit(event); });
        };
        DebounceClickDirective.prototype.ngOnDestroy = function () {
            this.subscription.unsubscribe();
        };
        DebounceClickDirective.prototype.clickEvent = function (event) {
            event.preventDefault();
            event.stopPropagation();
            this.clicks.next(event);
        };
        return DebounceClickDirective;
    }());
    DebounceClickDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[debounceClick]'
                },] }
    ];
    DebounceClickDirective.ctorParameters = function () { return []; };
    DebounceClickDirective.propDecorators = {
        debounceTime: [{ type: core.Input }],
        debounceClick: [{ type: core.Output }],
        clickEvent: [{ type: core.HostListener, args: ["click", ["$event"],] }]
    };

    var DebounceButtonModule = /** @class */ (function () {
        function DebounceButtonModule() {
        }
        return DebounceButtonModule;
    }());
    DebounceButtonModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        DebounceButtonComponent, DebounceClickDirective
                    ],
                    imports: [
                        common.CommonModule,
                        angular.IonicModule
                    ],
                    exports: [
                        DebounceButtonComponent
                    ]
                },] }
    ];

    var SpinnerComponent = /** @class */ (function () {
        function SpinnerComponent() {
        }
        return SpinnerComponent;
    }());
    SpinnerComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'spinner',
                    template: "<div #ref><ng-content></ng-content></div>\n\n<ng-container *ngIf=\"ref.childNodes.length == 0\">\n  <ion-content *ngIf=\"withContainer; else withoutContainer\">\n    <centralizer>\n      <div class=\"rotating-square\" *ngIf=\"name === 'rotatingSquare'\"></div>\n      <div class=\"chasing-dot\" *ngIf=\"name === 'chasingDot'\">\n        <div class=\"chasing-dot__dot\"></div>\n        <div class=\"chasing-dot__dot\"></div>\n        <div class=\"chasing-dot__dot\"></div>\n        <div class=\"chasing-dot__dot\"></div>\n        <div class=\"chasing-dot__dot\"></div>\n        <div class=\"chasing-dot__dot\"></div>\n      </div>\n      <div class=\"double-bouncing-dot\" *ngIf=\"name === 'doubleBouncingDot'\">\n        <div class=\"double-bouncing-dot__dot1\"></div>\n        <div class=\"double-bouncing-dot__dot2\"></div>\n      </div>\n      <div class=\"stretching-bars\" *ngIf=\"name === 'stretchingBars'\">\n        <div class=\"stretching-bars__rect1\"></div>\n        <div class=\"stretching-bars__rect2\"></div>\n        <div class=\"stretching-bars__rect3\"></div>\n        <div class=\"stretching-bars__rect4\"></div>\n        <div class=\"stretching-bars__rect5\"></div>\n      </div>\n      <div class=\"chasing-squares\" *ngIf=\"name === 'chasingSquares'\">\n        <div class=\"chasing-squares__square1\"></div>\n        <div class=\"chasing-squares__square2\"></div>\n      </div>\n      <div class=\"scaling-dot\" *ngIf=\"name === 'scalingDot'\"></div>\n      <div class=\"double-rotating-dot\" *ngIf=\"name === 'doubleRotatingDot'\">\n        <div class=\"double-rotating-dot__dot1\"></div>\n        <div class=\"double-rotating-dot__dot2\"></div>\n      </div>\n      <div class=\"three-bouncing-dot\" *ngIf=\"name === 'threeBouncingDots'\">\n        <div class=\"three-bouncing-dot__dot1\"></div>\n        <div class=\"three-bouncing-dot__dot2\"></div>\n        <div class=\"three-bouncing-dot__dot3\"></div>\n      </div>\n      <div class=\"rotating-dot-circle\" *ngIf=\"name === 'rotatingDotCircle'\">\n        <div class=\"rotating-dot-circle__dot1\"></div>\n        <div class=\"rotating-dot-circle__dot2\"></div>\n        <div class=\"rotating-dot-circle__dot3\"></div>\n        <div class=\"rotating-dot-circle__dot4\"></div>\n        <div class=\"rotating-dot-circle__dot5\"></div>\n        <div class=\"rotating-dot-circle__dot6\"></div>\n        <div class=\"rotating-dot-circle__dot7\"></div>\n        <div class=\"rotating-dot-circle__dot8\"></div>\n        <div class=\"rotating-dot-circle__dot9\"></div>\n        <div class=\"rotating-dot-circle__dot10\"></div>\n        <div class=\"rotating-dot-circle__dot11\"></div>\n        <div class=\"rotating-dot-circle__dot12\"></div>\n      </div>\n      <div class=\"fading-square\" *ngIf=\"name === 'fadingSquare'\">\n        <div class=\"fading-square__square1\"></div>\n        <div class=\"fading-square__square2\"></div>\n        <div class=\"fading-square__square3\"></div>\n        <div class=\"fading-square__square4\"></div>\n        <div class=\"fading-square__square5\"></div>\n        <div class=\"fading-square__square6\"></div>\n        <div class=\"fading-square__square7\"></div>\n        <div class=\"fading-square__square8\"></div>\n        <div class=\"fading-square__square9\"></div>\n      </div>\n      <div class=\"simple-circle\" *ngIf=\"name === 'simpleSpinner'\">\n        <div class=\"simple-circle__circle1\"></div>\n        <div class=\"simple-circle__circle2\"></div>\n        <div class=\"simple-circle__circle3\"></div>\n        <div class=\"simple-circle__circle4\"></div>\n        <div class=\"simple-circle__circle5\"></div>\n        <div class=\"simple-circle__circle6\"></div>\n        <div class=\"simple-circle__circle7\"></div>\n        <div class=\"simple-circle__circle8\"></div>\n        <div class=\"simple-circle__circle9\"></div>\n        <div class=\"simple-circle__circle10\"></div>\n        <div class=\"simple-circle__circle11\"></div>\n        <div class=\"simple-circle__circle12\"></div>\n      </div>\n      <div class=\"folding-square\" *ngIf=\"name === 'foldingSquare'\">\n        <div class=\"folding-square__square1\"></div>\n        <div class=\"folding-square__square2\"></div>\n        <div class=\"folding-square__square4\"></div>\n        <div class=\"folding-square__square3\"></div>\n      </div>\n    </centralizer>\n  </ion-content>\n  <ng-template #withoutContainer>\n    <div class=\"rotating-square\" *ngIf=\"name === 'rotatingSquare'\"></div>\n    <div class=\"chasing-dot\" *ngIf=\"name === 'chasingDot'\">\n      <div class=\"chasing-dot__dot\"></div>\n      <div class=\"chasing-dot__dot\"></div>\n      <div class=\"chasing-dot__dot\"></div>\n      <div class=\"chasing-dot__dot\"></div>\n      <div class=\"chasing-dot__dot\"></div>\n      <div class=\"chasing-dot__dot\"></div>\n    </div>\n    <div class=\"double-bouncing-dot\" *ngIf=\"name === 'doubleBouncingDot'\">\n      <div class=\"double-bouncing-dot__dot1\"></div>\n      <div class=\"double-bouncing-dot__dot2\"></div>\n    </div>\n    <div class=\"stretching-bars\" *ngIf=\"name === 'stretchingBars'\">\n      <div class=\"stretching-bars__rect1\"></div>\n      <div class=\"stretching-bars__rect2\"></div>\n      <div class=\"stretching-bars__rect3\"></div>\n      <div class=\"stretching-bars__rect4\"></div>\n      <div class=\"stretching-bars__rect5\"></div>\n    </div>\n    <div class=\"chasing-squares\" *ngIf=\"name === 'chasingSquares'\">\n      <div class=\"chasing-squares__square1\"></div>\n      <div class=\"chasing-squares__square2\"></div>\n    </div>\n    <div class=\"scaling-dot\" *ngIf=\"name === 'scalingDot'\"></div>\n    <div class=\"double-rotating-dot\" *ngIf=\"name === 'doubleRotatingDot'\">\n      <div class=\"double-rotating-dot__dot1\"></div>\n      <div class=\"double-rotating-dot__dot2\"></div>\n    </div>\n    <div class=\"three-bouncing-dot\" *ngIf=\"name === 'threeBouncingDots'\">\n      <div class=\"three-bouncing-dot__dot1\"></div>\n      <div class=\"three-bouncing-dot__dot2\"></div>\n      <div class=\"three-bouncing-dot__dot3\"></div>\n    </div>\n    <div class=\"rotating-dot-circle\" *ngIf=\"name === 'rotatingDotCircle'\">\n      <div class=\"rotating-dot-circle__dot1\"></div>\n      <div class=\"rotating-dot-circle__dot2\"></div>\n      <div class=\"rotating-dot-circle__dot3\"></div>\n      <div class=\"rotating-dot-circle__dot4\"></div>\n      <div class=\"rotating-dot-circle__dot5\"></div>\n      <div class=\"rotating-dot-circle__dot6\"></div>\n      <div class=\"rotating-dot-circle__dot7\"></div>\n      <div class=\"rotating-dot-circle__dot8\"></div>\n      <div class=\"rotating-dot-circle__dot9\"></div>\n      <div class=\"rotating-dot-circle__dot10\"></div>\n      <div class=\"rotating-dot-circle__dot11\"></div>\n      <div class=\"rotating-dot-circle__dot12\"></div>\n    </div>\n    <div class=\"fading-square\" *ngIf=\"name === 'fadingSquare'\">\n      <div class=\"fading-square__square1\"></div>\n      <div class=\"fading-square__square2\"></div>\n      <div class=\"fading-square__square3\"></div>\n      <div class=\"fading-square__square4\"></div>\n      <div class=\"fading-square__square5\"></div>\n      <div class=\"fading-square__square6\"></div>\n      <div class=\"fading-square__square7\"></div>\n      <div class=\"fading-square__square8\"></div>\n      <div class=\"fading-square__square9\"></div>\n    </div>\n    <div class=\"simple-circle\" *ngIf=\"name === 'simpleSpinner'\">\n      <div class=\"simple-circle__circle1\"></div>\n      <div class=\"simple-circle__circle2\"></div>\n      <div class=\"simple-circle__circle3\"></div>\n      <div class=\"simple-circle__circle4\"></div>\n      <div class=\"simple-circle__circle5\"></div>\n      <div class=\"simple-circle__circle6\"></div>\n      <div class=\"simple-circle__circle7\"></div>\n      <div class=\"simple-circle__circle8\"></div>\n      <div class=\"simple-circle__circle9\"></div>\n      <div class=\"simple-circle__circle10\"></div>\n      <div class=\"simple-circle__circle11\"></div>\n      <div class=\"simple-circle__circle12\"></div>\n    </div>\n    <div class=\"folding-square\" *ngIf=\"name === 'foldingSquare'\">\n      <div class=\"folding-square__square1\"></div>\n      <div class=\"folding-square__square2\"></div>\n      <div class=\"folding-square__square4\"></div>\n      <div class=\"folding-square__square3\"></div>\n    </div>\n  </ng-template>\n</ng-container>",
                    styles: ["ion-content{--background:var(--content-background,rgba(0,0,0,0.15));height:100%;left:0;top:0;width:100%;z-index:var(--content-z-index,10000)}@-webkit-keyframes rotate-square{0%{-webkit-transform:perspective(120px)}50%{-webkit-transform:perspective(120px) rotateY(180deg)}to{-webkit-transform:perspective(120px) rotateY(180deg) rotateX(180deg)}}@keyframes rotate-square{0%{-webkit-transform:perspective(120px) rotateX(0deg) rotateY(0deg);transform:perspective(120px) rotateX(0deg) rotateY(0deg)}50%{-webkit-transform:perspective(120px) rotateX(-180.1deg) rotateY(0deg);transform:perspective(120px) rotateX(-180.1deg) rotateY(0deg)}to{-webkit-transform:perspective(120px) rotateX(-180deg) rotateY(-179.9deg);transform:perspective(120px) rotateX(-180deg) rotateY(-179.9deg)}}.rotating-square{-webkit-animation:rotate-square 1.2s ease-in-out infinite;animation:rotate-square 1.2s ease-in-out infinite;background-color:var(--color,#333);height:var(--size,40px);width:var(--size,40px)}@-webkit-keyframes chase{to{-webkit-transform:rotate(1turn)}}@keyframes chase{to{transform:rotate(1turn)}}@-webkit-keyframes chase-dot{80%,to{-webkit-transform:rotate(1turn)}}@keyframes chase-dot{80%,to{transform:rotate(1turn)}}@-webkit-keyframes chase-dot-before{50%{-webkit-transform:scale(.4)}0%,to{-webkit-transform:scale(1)}}@keyframes chase-dot-before{50%{transform:scale(.4)}0%,to{transform:scale(1)}}.chasing-dot{-webkit-animation:chase 2.5s linear infinite both;animation:chase 2.5s linear infinite both;height:var(--size,40px);margin:20px;position:relative;width:var(--size,40px)}.chasing-dot__dot{-webkit-animation:chase-dot 2s ease-in-out infinite both!important;animation:chase-dot 2s ease-in-out infinite both!important;height:100%;left:0;position:absolute;top:0;width:100%}.chasing-dot__dot:first-child{-webkit-animation-delay:-1.1s!important;animation-delay:-1.1s!important}.chasing-dot__dot:nth-child(2){-webkit-animation-delay:-1s!important;animation-delay:-1s!important}.chasing-dot__dot:nth-child(3){-webkit-animation-delay:-.9s!important;animation-delay:-.9s!important}.chasing-dot__dot:nth-child(4){-webkit-animation-delay:-.8s!important;animation-delay:-.8s!important}.chasing-dot__dot:nth-child(5){-webkit-animation-delay:-.7s!important;animation-delay:-.7s!important}.chasing-dot__dot:nth-child(6){-webkit-animation-delay:-.6s!important;animation-delay:-.6s!important}.chasing-dot__dot:before{-webkit-animation:chase-dot-before 2s ease-in-out infinite both!important;animation:chase-dot-before 2s ease-in-out infinite both!important;background-color:var(--color,#000);border-radius:100%;content:\"\";display:block;height:var(--element-size,10px);width:var(--element-size,10px)}.chasing-dot__dot:before:first-child{-webkit-animation-delay:-1.1s!important;animation-delay:-1.1s!important}.chasing-dot__dot:before:nth-child(2){-webkit-animation-delay:-1s!important;animation-delay:-1s!important}.chasing-dot__dot:before:nth-child(3){-webkit-animation-delay:-.9s!important;animation-delay:-.9s!important}.chasing-dot__dot:before:nth-child(4){-webkit-animation-delay:-.8s!important;animation-delay:-.8s!important}.chasing-dot__dot:before:nth-child(5){-webkit-animation-delay:-.7s!important;animation-delay:-.7s!important}.chasing-dot__dot:before:nth-child(6){-webkit-animation-delay:-.6s!important;animation-delay:-.6s!important}@-webkit-keyframes bounce{0%,to{-webkit-transform:scale(0)}50%{-webkit-transform:scale(1)}}@keyframes bounce{0%,to{transform:scale(0)}50%{transform:scale(1)}}.double-bouncing-dot{height:var(--size,40px);position:relative;width:var(--size,40px)}.double-bouncing-dot__dot1,.double-bouncing-dot__dot2{-webkit-animation:bounce 2s ease-in-out infinite;animation:bounce 2s ease-in-out infinite;background-color:var(--color,#333);border-radius:50%;height:100%;left:0;opacity:.6;position:absolute;top:0;width:100%}.double-bouncing-dot__dot2{-webkit-animation-delay:-1s;animation-delay:-1s}@-webkit-keyframes stretch-deltay{0%,40%,to{-webkit-transform:scaleY(.4)}20%{-webkit-transform:scaleY(1)}}@keyframes stretch-deltay{0%,40%,to{-webkit-transform:scaleY(.4);transform:scaleY(.4)}20%{-webkit-transform:scaleY(1);transform:scaleY(1)}}.stretching-bars{height:var(--size,40px);text-align:center;width:var(--size,40px)}.stretching-bars>div{-webkit-animation:stretch-deltay 1.2s ease-in-out infinite;animation:stretch-deltay 1.2s ease-in-out infinite;background-color:var(--color,#333);display:inline-block;height:100%;margin-right:var(--element-margin,1px);width:var(--element-size,6px)}.stretching-bars__rect2{-webkit-animation-delay:-1.1s!important;animation-delay:-1.1s!important}.stretching-bars__rect3{-webkit-animation-delay:-1s!important;animation-delay:-1s!important}.stretching-bars__rect4{-webkit-animation-delay:-.9s!important;animation-delay:-.9s!important}.stretching-bars__rect5{-webkit-animation-delay:-.8s!important;animation-delay:-.8s!important}@-webkit-keyframes square-chase{25%{-webkit-transform:translateX(42px) rotate(-90deg) scale(.5)}50%{-webkit-transform:translateX(42px) translateY(42px) rotate(-180deg)}75%{-webkit-transform:translateX(0) translateY(42px) rotate(-270deg) scale(.5)}to{-webkit-transform:rotate(-1turn)}}@keyframes square-chase{25%{transform:translateX(42px) rotate(-90deg) scale(.5)}50%{transform:translateX(42px) translateY(42px) rotate(-179deg)}50.1%{transform:translateX(42px) translateY(42px) rotate(-180deg)}75%{transform:translateX(0) translateY(42px) rotate(-270deg) scale(.5)}to{transform:rotate(-1turn)}}.chasing-squares{height:var(--size,40px);position:relative;width:var(--size,40px)}.chasing-squares__square1,.chasing-squares__square2{-webkit-animation:square-chase 1.8s ease-in-out infinite;animation:square-chase 1.8s ease-in-out infinite;background-color:var(--color,#333);height:var(--element-size,15px);left:0;position:absolute;top:0;width:var(--element-size,15px)}.chasing-squares__square2{-webkit-animation-delay:-.9s;animation-delay:-.9s}@-webkit-keyframes scaleout{0%{-webkit-transform:scale(0)}to{-webkit-transform:scale(1);opacity:0}}@keyframes scaleout{0%{transform:scale(0)}to{opacity:0;transform:scale(1)}}.scaling-dot{-webkit-animation:scaleout 1s ease-in-out infinite;animation:scaleout 1s ease-in-out infinite;background-color:var(--color,#333);border-radius:100%;height:var(--size,40px);width:var(--size,40px)}@-webkit-keyframes rotate{to{-webkit-transform:rotate(1turn)}}@keyframes rotate{to{-webkit-transform:rotate(1turn);transform:rotate(1turn)}}.double-rotating-dot{-webkit-animation:rotate 2s linear infinite;animation:rotate 2s linear infinite;height:var(--size,40px);position:relative;text-align:center;width:var(--size,40px)}.double-rotating-dot__dot1,.double-rotating-dot__dot2{-webkit-animation:bounce 2s ease-in-out infinite;animation:bounce 2s ease-in-out infinite;background-color:var(--color,#333);border-radius:100%;display:inline-block;height:var(--element-size,60%);position:absolute;top:0;width:var(--element-size,60%)}.double-rotating-dot__dot2{-webkit-animation-delay:-1s;animation-delay:-1s;bottom:0;top:auto}@-webkit-keyframes bouncedelay{0%,80%,to{-webkit-transform:scale(0)}40%{-webkit-transform:scale(1)}}@keyframes bouncedelay{0%,80%,to{transform:scale(0)}40%{transform:scale(1)}}.three-bouncing-dot{text-align:center;width:var(--size,70px)}.three-bouncing-dot>div{-webkit-animation:bouncedelay 1.4s ease-in-out infinite both;animation:bouncedelay 1.4s ease-in-out infinite both;background-color:var(--color,#333);border-radius:100%;display:inline-block;height:var(--element-size,18px);margin-right:var(--element-margin,5px);width:var(--element-size,18px)}.three-bouncing-dot__dot1{-webkit-animation-delay:-.32s!important;animation-delay:-.32s!important}.three-bouncing-dot__dot2{-webkit-animation-delay:-.16s!important;animation-delay:-.16s!important}@-webkit-keyframes circle-bounce{0%,80%,to{transform:scale(0)}40%{transform:scale(1)}}@keyframes circle-bounce{0%,80%,to{transform:scale(0)}40%{transform:scale(1)}}.rotating-dot-circle{height:var(--size,40px);position:relative;width:var(--size,40px)}.rotating-dot-circle>div{height:100%;left:0;position:absolute;top:0;width:100%}.rotating-dot-circle>div:before{-webkit-animation:circle-bounce 1.2s ease-in-out infinite both;animation:circle-bounce 1.2s ease-in-out infinite both;background-color:var(--color,#333);border-radius:100%;content:\"\";display:block;height:var(--element-size,15%);margin:0 auto;width:var(--element-size,15%)}.rotating-dot-circle__dot2{transform:rotate(30deg)}.rotating-dot-circle__dot2:before{-webkit-animation-delay:-1.1s!important;animation-delay:-1.1s!important}.rotating-dot-circle__dot3{transform:rotate(60deg)}.rotating-dot-circle__dot3:before{-webkit-animation-delay:-1s!important;animation-delay:-1s!important}.rotating-dot-circle__dot4{transform:rotate(90deg)}.rotating-dot-circle__dot4:before{-webkit-animation-delay:-.9s!important;animation-delay:-.9s!important}.rotating-dot-circle__dot5{transform:rotate(120deg)}.rotating-dot-circle__dot5:before{-webkit-animation-delay:-.8s!important;animation-delay:-.8s!important}.rotating-dot-circle__dot6{transform:rotate(150deg)}.rotating-dot-circle__dot6:before{-webkit-animation-delay:-.7s!important;animation-delay:-.7s!important}.rotating-dot-circle__dot7{transform:rotate(180deg)}.rotating-dot-circle__dot7:before{-webkit-animation-delay:-.6s!important;animation-delay:-.6s!important}.rotating-dot-circle__dot8{transform:rotate(210deg)}.rotating-dot-circle__dot8:before{-webkit-animation-delay:-.5s!important;animation-delay:-.5s!important}.rotating-dot-circle__dot9{transform:rotate(240deg)}.rotating-dot-circle__dot9:before{-webkit-animation-delay:-.4s!important;animation-delay:-.4s!important}.rotating-dot-circle__dot10{transform:rotate(270deg)}.rotating-dot-circle__dot10:before{-webkit-animation-delay:-.3s!important;animation-delay:-.3s!important}.rotating-dot-circle__dot11{transform:rotate(300deg)}.rotating-dot-circle__dot11:before{-webkit-animation-delay:-.2s!important;animation-delay:-.2s!important}.rotating-dot-circle__dot12{transform:rotate(330deg)}.rotating-dot-circle__dot12:before{-webkit-animation-delay:-.1s!important;animation-delay:-.1s!important}@-webkit-keyframes square-scale{0%,70%,to{transform:scaleX(1)}35%{transform:scale3D(0,0,1)}}@keyframes square-scale{0%,70%,to{transform:scaleX(1)}35%{transform:scale3D(0,0,1)}}.fading-square{height:var(--size,40px);width:var(--size,40px)}.fading-square>div{-webkit-animation:square-scale 1.3s ease-in-out infinite;animation:square-scale 1.3s ease-in-out infinite;background-color:var(--color,#333);float:left;height:var(--element-size,33%);width:var(--element-size,33%)}.fading-square__square1{-webkit-animation-delay:.2s!important;animation-delay:.2s!important}.fading-square__square2{-webkit-animation-delay:.3s!important;animation-delay:.3s!important}.fading-square__square3{-webkit-animation-delay:.4s!important;animation-delay:.4s!important}.fading-square__square4{-webkit-animation-delay:.1s!important;animation-delay:.1s!important}.fading-square__square5{-webkit-animation-delay:.2s!important;animation-delay:.2s!important}.fading-square__square6{-webkit-animation-delay:.3s!important;animation-delay:.3s!important}.fading-square__square7{-webkit-animation-delay:0s!important;animation-delay:0s!important}.fading-square__square8{-webkit-animation-delay:.1s!important;animation-delay:.1s!important}.fading-square__square9{-webkit-animation-delay:.2s!important;animation-delay:.2s!important}@-webkit-keyframes spinner-rotation{0%,39%,to{opacity:0}40%{opacity:1}}@keyframes spinner-rotation{0%,39%,to{opacity:0}40%{opacity:1}}.simple-circle{height:var(--size,40px);position:relative;width:var(--size,40px)}.simple-circle>div{height:100%;left:0;position:absolute;top:0;width:100%}.simple-circle>div:before{-webkit-animation:spinner-rotation 1.2s ease-in-out infinite both;animation:spinner-rotation 1.2s ease-in-out infinite both;background-color:var(--color,#333);border-radius:100%;content:\"\";display:block;height:var(--element-size,15%);margin:0 auto;width:var(--element-size,15%)}.simple-circle__circle2{transform:rotate(30deg)}.simple-circle__circle2:before{-webkit-animation-delay:-1.1s!important;animation-delay:-1.1s}.simple-circle__circle3{transform:rotate(60deg)}.simple-circle__circle3:before{-webkit-animation-delay:-1s!important;animation-delay:-1s}.simple-circle__circle4{transform:rotate(90deg)}.simple-circle__circle4:before{-webkit-animation-delay:-.9s!important;animation-delay:-.9s}.simple-circle__circle5{transform:rotate(120deg)}.simple-circle__circle5:before{-webkit-animation-delay:-.8s!important;animation-delay:-.8s}.simple-circle__circle6{transform:rotate(150deg)}.simple-circle__circle6:before{-webkit-animation-delay:-.7s!important;animation-delay:-.7s}.simple-circle__circle7{transform:rotate(180deg)}.simple-circle__circle7:before{-webkit-animation-delay:-.6s!important;animation-delay:-.6s}.simple-circle__circle8{transform:rotate(210deg)}.simple-circle__circle8:before{-webkit-animation-delay:-.5s!important;animation-delay:-.5s}.simple-circle__circle9{transform:rotate(240deg)}.simple-circle__circle9:before{-webkit-animation-delay:-.4s!important;animation-delay:-.4s}.simple-circle__circle10{transform:rotate(270deg)}.simple-circle__circle10:before{-webkit-animation-delay:-.3s!important;animation-delay:-.3s}.simple-circle__circle11{transform:rotate(300deg)}.simple-circle__circle11:before{-webkit-animation-delay:-.2s!important;animation-delay:-.2s}.simple-circle__circle12{transform:rotate(330deg)}.simple-circle__circle12:before{-webkit-animation-delay:-.1s!important;animation-delay:-.1s}@-webkit-keyframes fold{0%,10%{opacity:0;transform:perspective(140px) rotateX(-180deg)}25%,75%{opacity:1;transform:perspective(140px) rotateX(0deg)}90%,to{opacity:0;transform:perspective(140px) rotateY(180deg)}}@keyframes fold{0%,10%{opacity:0;transform:perspective(140px) rotateX(-180deg)}25%,75%{opacity:1;transform:perspective(140px) rotateX(0deg)}90%,to{opacity:0;transform:perspective(140px) rotateY(180deg)}}.folding-square{height:var(--size,40px);position:relative;transform:rotate(45deg);width:var(--size,40px)}.folding-square>div{float:left;height:50%;position:relative;transform:scale(1.1);width:50%}.folding-square>div:before{-webkit-animation:fold 2.4s linear infinite both;animation:fold 2.4s linear infinite both;background-color:var(--color,#333);content:\"\";height:100%;left:0;position:absolute;top:0;transform-origin:100% 100%;width:100%}.folding-square__square2{transform:scale(1.1) rotate(90deg)!important}.folding-square__square2:before{-webkit-animation-delay:.3s!important;animation-delay:.3s!important}.folding-square__square3{transform:scale(1.1) rotate(180deg)!important}.folding-square__square3:before{-webkit-animation-delay:.6s!important;animation-delay:.6s!important}.folding-square__square4{transform:scale(1.1) rotate(270deg)!important}.folding-square__square4:before{-webkit-animation-delay:.9s!important;animation-delay:.9s!important}"]
                },] }
    ];
    SpinnerComponent.propDecorators = {
        withContainer: [{ type: core.Input }],
        name: [{ type: core.Input }]
    };

    var SpinnerModule = /** @class */ (function () {
        function SpinnerModule() {
        }
        return SpinnerModule;
    }());
    SpinnerModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        SpinnerComponent
                    ],
                    imports: [
                        common.CommonModule,
                        angular.IonicModule,
                        CentralizerModule
                    ],
                    exports: [
                        SpinnerComponent
                    ]
                },] }
    ];

    var ErrorContainerComponent = /** @class */ (function () {
        function ErrorContainerComponent() {
            this.reload = new core.EventEmitter();
        }
        return ErrorContainerComponent;
    }());
    ErrorContainerComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'error-container',
                    template: "<div #ref><ng-content></ng-content></div>\n\n<div class=\"error\" *ngIf=\"ref.childNodes.length == 0\">\n  <span class=\"error__message\" [innerHtml]=\"message\"></span>\n  <ion-button class=\"error__button\" [fill]=\"buttonFill\" [shape]=\"buttonShape\" [color]=\"buttonColor\" *ngIf=\"buttonLabel && buttonLabel.length\" (click)=\"reload.emit()\">\n    <span>{{buttonLabel}}</span>\n  </ion-button>\n</div>\n",
                    styles: [".error{padding:var(--padding-top,0) var(--padding-right,0) var(--padding-bottom,0) var(--padding-left,0);text-align:var(--align,center);width:var(--width,100%)}.error__message{color:var(--message-color,#ddd);display:inline-block;font-size:var(--message-font-size,18px);font-weight:var(--message-font-weight,400);margin-bottom:var(--message-margin-bottom,15px);text-align:var(--message-align,left);width:100%}.error__button{height:var(--button-height)!important;width:var(--button-width)!important}"]
                },] }
    ];
    ErrorContainerComponent.propDecorators = {
        message: [{ type: core.Input }],
        buttonLabel: [{ type: core.Input, args: ['retryButtonLabel',] }],
        buttonFill: [{ type: core.Input, args: ['retryButtonFill',] }],
        buttonShape: [{ type: core.Input, args: ['retryButtonShape',] }],
        buttonColor: [{ type: core.Input, args: ['retryButtonColor',] }],
        reload: [{ type: core.Output }]
    };

    var ErrorContainerModule = /** @class */ (function () {
        function ErrorContainerModule() {
        }
        return ErrorContainerModule;
    }());
    ErrorContainerModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        ErrorContainerComponent
                    ],
                    imports: [
                        common.CommonModule,
                        angular.IonicModule,
                    ],
                    exports: [
                        ErrorContainerComponent
                    ]
                },] }
    ];

    var WsDataComponent = /** @class */ (function () {
        function WsDataComponent() {
            this.retry = new core.EventEmitter();
        }
        return WsDataComponent;
    }());
    WsDataComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'ws-data',
                    template: "<spinner class=\"spinner\" *ngIf=\"options.loading$ | async; else callEndend\" [withContainer]=\"options.loadingSpinnerWithContainer\" [name]=\"options.loadingSpinnerName\">\n  <ng-content select=[customSpinner]></ng-content>\n</spinner>\n<ng-template #callEndend>\n  <error-container class=\"error-container\" *ngIf=\"options.error$ | async\"\n    [message]=\"options.errorMessage\" [retryButtonLabel]=\"options.errorRetryButtonLabel\"\n    [retryButtonFill]=\"options.errorRetryButtonFill\" [retryButtonShape]=\"options.errorRetryButtonShape\"\n    [retryButtonColor]=\"options.errorRetryButtonColor\" (reload)=\"retry.emit()\">\n    <ng-content select=[customError]></ng-content>\n  </error-container>\n\n  <ng-content select=[dataContent]></ng-content>\n</ng-template>",
                    styles: [".spinner{--color:var(--spinner-color);--content-background:var(--spinner-content-background,transparent);--content-z-index:var(--spinner-content-z-index,rgba(0,0,0,0.15));--element-margin:var(--spinner-element-margin);--element-size:var(--spinner-element-size);--size:var(--spinner-size)}.error-container{--align:var(--error-container-align);--button-height:var(--error-container-button-height);--button-width:var(--error-container-button-width);--message-align:var(--error-container-message-align);--message-color:var(--error-container-message-color);--message-font-size:var(--error-container-message-font-size);--message-font-weight:var(--error-container-message-font-weight);--message-margin-bottom:var(--error-container-message-margin-bottom);--padding-bottom:var(--error-container-padding-bottom);--padding-left:var(--error-container-padding-left);--padding-right:var(--error-container-padding-right);--padding-top:var(--error-container-padding-top);--width:var(--error-container-width)}"]
                },] }
    ];
    WsDataComponent.propDecorators = {
        options: [{ type: core.Input }],
        retry: [{ type: core.Output }]
    };

    var WsDataModule = /** @class */ (function () {
        function WsDataModule() {
        }
        return WsDataModule;
    }());
    WsDataModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        WsDataComponent
                    ],
                    imports: [
                        common.CommonModule,
                        angular.IonicModule,
                        SpinnerModule,
                        ErrorContainerModule
                    ],
                    exports: [
                        WsDataComponent
                    ]
                },] }
    ];

    var WsDataListComponent = /** @class */ (function () {
        function WsDataListComponent() {
            this.retry = new core.EventEmitter();
        }
        WsDataListComponent.prototype.ngOnInit = function () {
            this.dataAvailableCondition$ = (typeof this.options.dataAvailableCondition === 'boolean') ? rxjs.of(this.options.dataAvailableCondition) : this.options.dataAvailableCondition;
        };
        return WsDataListComponent;
    }());
    WsDataListComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'ws-data-list',
                    template: "<spinner class=\"spinner\" *ngIf=\"options.loading$ | async; else callEndend\" [withContainer]=\"options.loadingSpinnerWithContainer\" [name]=\"options.loadingSpinnerName\">\n  <ng-content select=[customSpinner]></ng-content>\n</spinner>\n<ng-template #callEndend>\n  <error-container class=\"error-container\" *ngIf=\"options.error$ | async\"\n    [message]=\"options.errorMessage\" [retryButtonLabel]=\"options.errorRetryButtonLabel\"\n    [retryButtonFill]=\"options.errorRetryButtonFill\" [retryButtonShape]=\"options.errorRetryButtonShape\"\n    [retryButtonColor]=\"options.errorRetryButtonColor\" (reload)=\"retry.emit()\">\n    <ng-content select=[customError]></ng-content>\n  </error-container>\n\n  <ng-container *ngIf=\"dataAvailableCondition$ | async\">\n    <ng-container *ngIf=\"(options.data$ | async) as items\">\n      <error-container [message]=\"options.emptyListMessage\" *ngIf=\"!items.length\">\n        <ng-content select=[customEmptyListError]></ng-content>\n      </error-container>\n  \n      <ng-container *ngFor=\"let item of items\">\n        <ng-container *ngTemplateOutlet=\"options.dataItemTemplate; context: {$implicit: item}\"></ng-container>\n      </ng-container>\n    </ng-container>\n  </ng-container>\n</ng-template>",
                    styles: [".spinner{--color:var(--spinner-color);--content-background:var(--spinner-content-background,transparent);--content-z-index:var(--spinner-content-z-index,rgba(0,0,0,0.15));--element-margin:var(--spinner-element-margin);--element-size:var(--spinner-element-size);--size:var(--spinner-size)}.error-container{--align:var(--error-container-align);--button-height:var(--error-container-button-height);--button-width:var(--error-container-button-width);--message-align:var(--error-container-message-align);--message-color:var(--error-container-message-color);--message-font-size:var(--error-container-message-font-size);--message-font-weight:var(--error-container-message-font-weight);--message-margin-bottom:var(--error-container-message-margin-bottom);--padding-bottom:var(--error-container-padding-bottom);--padding-left:var(--error-container-padding-left);--padding-right:var(--error-container-padding-right);--padding-top:var(--error-container-padding-top);--width:var(--error-container-width)}"]
                },] }
    ];
    WsDataListComponent.propDecorators = {
        options: [{ type: core.Input }],
        retry: [{ type: core.Output }]
    };

    var WsDataListModule = /** @class */ (function () {
        function WsDataListModule() {
        }
        return WsDataListModule;
    }());
    WsDataListModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        WsDataListComponent
                    ],
                    imports: [
                        common.CommonModule,
                        angular.IonicModule,
                        SpinnerModule,
                        ErrorContainerModule
                    ],
                    exports: [
                        WsDataListComponent
                    ]
                },] }
    ];

    ;

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var LibConfigService = new core.InjectionToken('LibConfig');
    var IonicAngularUtilitiesModule = /** @class */ (function () {
        function IonicAngularUtilitiesModule() {
        }
        IonicAngularUtilitiesModule.forRoot = function (config) {
            return {
                ngModule: IonicAngularUtilitiesModule,
                providers: [
                    //Here provide services
                    {
                        provide: LibConfigService,
                        useValue: config
                    }
                ]
            };
        };
        return IonicAngularUtilitiesModule;
    }());
    IonicAngularUtilitiesModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [],
                    imports: [
                        common.CommonModule,
                        angular.IonicModule
                    ],
                    exports: []
                },] }
    ];

    ////////////////////Mock providers
    var Mock = /** @class */ (function () {
        function Mock(config) {
            this.config = config;
        }
        Mock.prototype.isMockAvailable = function (mock) {
            return this.config && this.config.ionicMock && this.config.ionicMock[mock];
        };
        return Mock;
    }());
    Mock.decorators = [
        { type: core.Injectable }
    ];
    Mock.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: core.Inject, args: [LibConfigService,] }] }
    ]; };
    var AppVersionMock = /** @class */ (function (_super) {
        __extends(AppVersionMock, _super);
        function AppVersionMock() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AppVersionMock.prototype.getAppName = function () {
            var _this = this;
            return new Promise(function (resolve, reject) {
                if (_this.isMockAvailable('appVersion'))
                    _this.config.ionicMock.appVersion.appName ?
                        resolve(_this.config.ionicMock.appVersion.appName) :
                        reject('An error occured retrieving appName data from AppVersion mock');
            });
        };
        AppVersionMock.prototype.getPackageName = function () {
            var _this = this;
            return new Promise(function (resolve, reject) {
                if (_this.isMockAvailable('appVersion'))
                    _this.config.ionicMock.appVersion.packageName ?
                        resolve(_this.config.ionicMock.appVersion.packageName) :
                        reject('An error occured retrieving packageName data from AppVersion mock');
            });
        };
        AppVersionMock.prototype.getVersionCode = function () {
            var _this = this;
            return new Promise(function (resolve, reject) {
                if (_this.isMockAvailable('appVersion'))
                    _this.config.ionicMock.appVersion.versionCode ?
                        resolve(_this.config.ionicMock.appVersion.versionCode) :
                        reject('An error occured retrieving versionCode data from AppVersion mock');
            });
        };
        AppVersionMock.prototype.getVersionNumber = function () {
            var _this = this;
            return new Promise(function (resolve, reject) {
                if (_this.isMockAvailable('appVersion'))
                    _this.config.ionicMock.appVersion.versionNumber ?
                        resolve(_this.config.ionicMock.appVersion.versionNumber) :
                        reject('An error occured retrieving versionNumber data from AppVersion mock');
            });
        };
        return AppVersionMock;
    }(Mock));
    AppVersionMock.decorators = [
        { type: core.Injectable }
    ];
    var DeviceMock = /** @class */ (function (_super) {
        __extends(DeviceMock, _super);
        function DeviceMock() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            _this.cordova = _this.isMockAvailable('device') && _this.config.ionicMock.device.cordova ? _this.config.ionicMock.device.cordova : "browser";
            _this.model = _this.isMockAvailable('device') && _this.config.ionicMock.device.cordova ? _this.config.ionicMock.device.model : "not available";
            _this.platform = _this.isMockAvailable('device') && _this.config.ionicMock.device.cordova ? _this.config.ionicMock.device.platform : "not available";
            _this.uuid = _this.isMockAvailable('device') && _this.config.ionicMock.device.cordova ? _this.config.ionicMock.device.uuid : "not available";
            _this.version = _this.isMockAvailable('device') && _this.config.ionicMock.device.cordova ? _this.config.ionicMock.device.version : "not available";
            _this.manufacturer = _this.isMockAvailable('device') && _this.config.ionicMock.device.cordova ? _this.config.ionicMock.device.manufacturer : "not available";
            _this.isVirtual = _this.isMockAvailable('device') && _this.config.ionicMock.device.cordova ? _this.config.ionicMock.device.isVirtual : true;
            _this.serial = _this.isMockAvailable('device') && _this.config.ionicMock.device.cordova ? _this.config.ionicMock.device.serial : "not available";
            return _this;
        }
        return DeviceMock;
    }(Mock));
    DeviceMock.decorators = [
        { type: core.Injectable }
    ];
    var MediaMock = /** @class */ (function () {
        function MediaMock() {
        }
        return MediaMock;
    }());
    MediaMock.decorators = [
        { type: core.Injectable }
    ];
    var NativeStorageMock = /** @class */ (function () {
        function NativeStorageMock() {
        }
        NativeStorageMock.prototype.setItem = function (reference, value) {
            localStorage.setItem(reference, value);
            return new Promise(function (resolve, reject) {
                resolve({});
            });
        };
        NativeStorageMock.prototype.getItem = function (reference) {
            var value = localStorage.getItem(reference);
            return new Promise(function (resolve, reject) {
                resolve(value);
            });
        };
        NativeStorageMock.prototype.remove = function (reference) {
            localStorage.removeItem(reference);
            return new Promise(function (resolve, reject) {
                resolve({});
            });
        };
        return NativeStorageMock;
    }());
    NativeStorageMock.decorators = [
        { type: core.Injectable }
    ];
    var HTTPMock = /** @class */ (function () {
        function HTTPMock(http) {
            this.http = http;
        }
        HTTPMock.prototype.get = function (endpoint, params, header) {
            var _this = this;
            return new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
                var response, err_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 2, , 3]);
                            return [4 /*yield*/, this.http.get(endpoint, { headers: header }).toPromise()];
                        case 1:
                            response = _a.sent();
                            resolve({ data: JSON.stringify(response) });
                            return [3 /*break*/, 3];
                        case 2:
                            err_1 = _a.sent();
                            reject(err_1);
                            return [3 /*break*/, 3];
                        case 3: return [2 /*return*/];
                    }
                });
            }); });
        };
        HTTPMock.prototype.post = function (endpoint, body, header) {
            var _this = this;
            return new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
                var response, err_2;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 2, , 3]);
                            return [4 /*yield*/, this.http.post(endpoint, body, { headers: header }).toPromise()];
                        case 1:
                            response = _a.sent();
                            resolve({ data: JSON.stringify(response) });
                            return [3 /*break*/, 3];
                        case 2:
                            err_2 = _a.sent();
                            reject(err_2);
                            return [3 /*break*/, 3];
                        case 3: return [2 /*return*/];
                    }
                });
            }); });
        };
        HTTPMock.prototype.setDataSerializer = function () {
        };
        HTTPMock.prototype.setRequestTimeout = function (timeout) {
            return;
        };
        return HTTPMock;
    }());
    HTTPMock.decorators = [
        { type: core.Injectable }
    ];
    HTTPMock.ctorParameters = function () { return [
        { type: http.HttpClient }
    ]; };
    var StatusBarMock = /** @class */ (function () {
        function StatusBarMock() {
        }
        StatusBarMock.prototype.hide = function () {
        };
        return StatusBarMock;
    }());
    StatusBarMock.decorators = [
        { type: core.Injectable }
    ];
    var NavigationBarMock = /** @class */ (function () {
        function NavigationBarMock() {
        }
        NavigationBarMock.prototype.setUp = function (autohide) {
            return new Promise(function (resolve, reject) {
                resolve({});
            });
        };
        NavigationBarMock.prototype.hideNavigationBar = function () {
            return new Promise(function (resolve, reject) {
                resolve({});
            });
        };
        return NavigationBarMock;
    }());
    NavigationBarMock.decorators = [
        { type: core.Injectable }
    ];
    var AndroidFullScreenMock = /** @class */ (function () {
        function AndroidFullScreenMock() {
        }
        AndroidFullScreenMock.prototype.isImmersiveModeSupported = function () {
            return new Promise(function (resolve, rejcet) {
                resolve();
            });
        };
        AndroidFullScreenMock.prototype.immersiveMode = function () {
            return new Promise(function (resolve, rejcet) {
                resolve();
            });
        };
        AndroidFullScreenMock.prototype.leanMode = function () {
            return new Promise(function (resolve, rejcet) {
                resolve();
            });
        };
        return AndroidFullScreenMock;
    }());
    AndroidFullScreenMock.decorators = [
        { type: core.Injectable }
    ];
    var NativeAudioMock = /** @class */ (function () {
        function NativeAudioMock() {
        }
        NativeAudioMock.prototype.preloadSimple = function (id, path) {
            return new Promise(function (resolve, reject) {
                resolve();
            });
        };
        NativeAudioMock.prototype.preloadComplex = function (id, path, volume, voices, delay) {
            return new Promise(function (resolve, reject) {
                resolve();
            });
        };
        NativeAudioMock.prototype.play = function (id, callback) {
            return new Promise(function (resolve, reject) {
                resolve();
            });
        };
        NativeAudioMock.prototype.loop = function (id) {
            return new Promise(function (resolve, reject) {
                resolve();
            });
        };
        NativeAudioMock.prototype.stop = function (id) {
            return new Promise(function (resolve, reject) {
                resolve();
            });
        };
        return NativeAudioMock;
    }());
    NativeAudioMock.decorators = [
        { type: core.Injectable }
    ];
    var AdmobMock = /** @class */ (function () {
        function AdmobMock() {
        }
        AdmobMock.prototype.setOptions = function (option) {
            return new Promise(function (resolve, reject) {
                resolve();
            });
        };
        return AdmobMock;
    }());
    AdmobMock.decorators = [
        { type: core.Injectable }
    ];
    var DeeplinksMock = /** @class */ (function () {
        function DeeplinksMock() {
        }
        DeeplinksMock.prototype.route = function (paths) {
            return new rxjs.Observable();
        };
        return DeeplinksMock;
    }());
    DeeplinksMock.decorators = [
        { type: core.Injectable }
    ];
    /////////////////////Cordova verify function
    function hasCordova() {
        return window.hasOwnProperty('cordova');
    }
    /////////////////////Providers getters
    function getAppVersion() {
        return hasCordova() ? ngx.AppVersion : AppVersionMock;
    }
    function getDevice() {
        return hasCordova() ? ngx$1.Device : DeviceMock;
    }
    function getNativeStorage() {
        return hasCordova() ? ngx$2.NativeStorage : NativeStorageMock;
    }
    function getHTTP() {
        return hasCordova() ? ngx$3.HTTP : HTTPMock;
    }
    function getMedia() {
        return hasCordova() ? ngx$4.Media : MediaMock;
    }
    function getStatusBar() {
        return hasCordova() ? ngx$5.StatusBar : StatusBarMock;
    }
    function getNavigationBar() {
        return hasCordova() ? ngx$6.NavigationBar : NavigationBarMock;
    }
    function getAndroidFullScreen() {
        return hasCordova() ? ngx$7.AndroidFullScreen : AndroidFullScreenMock;
    }
    function getNativeAudio() {
        return hasCordova() ? ngx$8.NativeAudio : NativeAudioMock;
    }
    function getAdmob() {
        return hasCordova() ? ngx$9.Admob : AdmobMock;
    }
    function getDeeplinks() {
        return hasCordova() ? ngx$a.Deeplinks : DeeplinksMock;
    }

    ///////////// Components

    /**
     * Generated bundle index. Do not edit.
     */

    exports.AdmobMock = AdmobMock;
    exports.AndroidFullScreenMock = AndroidFullScreenMock;
    exports.AppVersionMock = AppVersionMock;
    exports.CentralizerComponent = CentralizerComponent;
    exports.CentralizerModule = CentralizerModule;
    exports.DebounceButtonComponent = DebounceButtonComponent;
    exports.DebounceButtonModule = DebounceButtonModule;
    exports.DebounceClickDirective = DebounceClickDirective;
    exports.DeeplinksMock = DeeplinksMock;
    exports.DeviceMock = DeviceMock;
    exports.ErrorContainerComponent = ErrorContainerComponent;
    exports.ErrorContainerModule = ErrorContainerModule;
    exports.HTTPMock = HTTPMock;
    exports.IonicAngularUtilitiesModule = IonicAngularUtilitiesModule;
    exports.LibConfigService = LibConfigService;
    exports.MediaMock = MediaMock;
    exports.NativeAudioMock = NativeAudioMock;
    exports.NativeStorageMock = NativeStorageMock;
    exports.NavigationBarMock = NavigationBarMock;
    exports.SpinnerComponent = SpinnerComponent;
    exports.SpinnerModule = SpinnerModule;
    exports.StatusBarMock = StatusBarMock;
    exports.WsDataComponent = WsDataComponent;
    exports.WsDataListComponent = WsDataListComponent;
    exports.WsDataListModule = WsDataListModule;
    exports.WsDataModule = WsDataModule;
    exports.getAdmob = getAdmob;
    exports.getAndroidFullScreen = getAndroidFullScreen;
    exports.getAppVersion = getAppVersion;
    exports.getDeeplinks = getDeeplinks;
    exports.getDevice = getDevice;
    exports.getHTTP = getHTTP;
    exports.getMedia = getMedia;
    exports.getNativeAudio = getNativeAudio;
    exports.getNativeStorage = getNativeStorage;
    exports.getNavigationBar = getNavigationBar;
    exports.getStatusBar = getStatusBar;
    exports.hasCordova = hasCordova;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ionic-angular-utilities.umd.js.map
