import { HttpClient } from '@angular/common/http';
import { Observable } from 'rxjs';
import { LibConfig } from '../ionic-angular-utilities.module';
declare class Mock {
    protected config: LibConfig;
    constructor(config: LibConfig);
    protected isMockAvailable(mock: string): any;
}
export declare class AppVersionMock extends Mock {
    getAppName(): Promise<string>;
    getPackageName(): Promise<string>;
    getVersionCode(): Promise<string | number>;
    getVersionNumber(): Promise<string>;
}
export declare class DeviceMock extends Mock {
    cordova: string;
    model: string;
    platform: string;
    uuid: string;
    version: string;
    manufacturer: string;
    isVirtual: boolean;
    serial: string;
}
export declare class MediaMock {
}
export declare class NativeStorageMock {
    setItem(reference: string, value: any): Promise<any>;
    getItem(reference: string): Promise<any>;
    remove(reference: string): Promise<any>;
}
export declare class HTTPMock {
    private http;
    constructor(http: HttpClient);
    get(endpoint: string, params?: any, header?: any): Promise<unknown>;
    post(endpoint: string, body?: any, header?: any): Promise<unknown>;
    setDataSerializer(): void;
    setRequestTimeout(timeout: number): void;
}
export declare class StatusBarMock {
    hide(): void;
}
export declare class NavigationBarMock {
    setUp(autohide?: any): Promise<any>;
    hideNavigationBar(): Promise<any>;
}
export declare class AndroidFullScreenMock {
    isImmersiveModeSupported(): Promise<void>;
    immersiveMode(): Promise<void>;
    leanMode(): Promise<void>;
}
export declare class NativeAudioMock {
    preloadSimple(id: string, path: string): Promise<any>;
    preloadComplex(id: string, path: string, volume: number, voices: number, delay: number): Promise<any>;
    play(id: string, callback?: Function): Promise<any>;
    loop(id: string): Promise<any>;
    stop(id: string): Promise<any>;
}
export declare class AdmobMock {
    setOptions(option: any): Promise<any>;
}
export declare class DeeplinksMock {
    route(paths: any): Observable<any>;
}
export declare function hasCordova(): boolean;
export declare function getAppVersion(): any;
export declare function getDevice(): any;
export declare function getNativeStorage(): any;
export declare function getHTTP(): any;
export declare function getMedia(): any;
export declare function getStatusBar(): any;
export declare function getNavigationBar(): any;
export declare function getAndroidFullScreen(): any;
export declare function getNativeAudio(): any;
export declare function getAdmob(): any;
export declare function getDeeplinks(): any;
export {};
